From 95bc57fc47dd069a67738cf26007442f38283979 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 01 2021 21:36:49 +0000
Subject: [PATCH 1929/2232] Remove RustName::to_symbol in favor of explicit resolve


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index d2dbe02..781d8b2 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -1315,7 +1315,7 @@ trait ToMangled {
 
 impl ToMangled for RustName {
     fn to_mangled(&self, types: &Types) -> Symbol {
-        self.to_symbol(types)
+        types.resolve(self).to_symbol()
     }
 }
 
@@ -1726,9 +1726,9 @@ fn write_unique_ptr_common(out: &mut OutFile, ty: UniquePtr) {
 }
 
 fn write_shared_ptr(out: &mut OutFile, ident: &RustName) {
-    let resolved = out.types.resolve(ident);
-    let inner = resolved.to_fully_qualified();
-    let instance = ident.to_symbol(out.types);
+    let resolve = out.types.resolve(ident);
+    let inner = resolve.to_fully_qualified();
+    let instance = resolve.to_symbol();
 
     out.include.new = true;
     out.include.utility = true;
@@ -1798,9 +1798,9 @@ fn write_shared_ptr(out: &mut OutFile, ident: &RustName) {
 }
 
 fn write_weak_ptr(out: &mut OutFile, ident: &RustName) {
-    let resolved = out.types.resolve(ident);
-    let inner = resolved.to_fully_qualified();
-    let instance = ident.to_symbol(out.types);
+    let resolve = out.types.resolve(ident);
+    let inner = resolve.to_fully_qualified();
+    let instance = resolve.to_symbol();
 
     out.include.new = true;
     out.include.utility = true;
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 85f834d..9cbb2c3 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -1072,7 +1072,8 @@ fn type_id(name: &Pair) -> TokenStream {
 }
 
 fn expand_rust_box(ident: &RustName, types: &Types) -> TokenStream {
-    let link_prefix = format!("cxxbridge1$box${}$", types.resolve(ident).to_symbol());
+    let resolve = types.resolve(ident);
+    let link_prefix = format!("cxxbridge1$box${}$", resolve.to_symbol());
     let link_alloc = format!("{}alloc", link_prefix);
     let link_dealloc = format!("{}dealloc", link_prefix);
     let link_drop = format!("{}drop", link_prefix);
@@ -1105,7 +1106,8 @@ fn expand_rust_box(ident: &RustName, types: &Types) -> TokenStream {
 }
 
 fn expand_rust_vec(elem: &RustName, types: &Types) -> TokenStream {
-    let link_prefix = format!("cxxbridge1$rust_vec${}$", elem.to_symbol(types));
+    let resolve = types.resolve(elem);
+    let link_prefix = format!("cxxbridge1$rust_vec${}$", resolve.to_symbol());
     let link_new = format!("{}new", link_prefix);
     let link_drop = format!("{}drop", link_prefix);
     let link_len = format!("{}len", link_prefix);
@@ -1167,7 +1169,8 @@ fn expand_rust_vec(elem: &RustName, types: &Types) -> TokenStream {
 
 fn expand_unique_ptr(ident: &RustName, types: &Types, explicit_impl: Option<&Impl>) -> TokenStream {
     let name = ident.rust.to_string();
-    let prefix = format!("cxxbridge1$unique_ptr${}$", ident.to_symbol(types));
+    let resolve = types.resolve(ident);
+    let prefix = format!("cxxbridge1$unique_ptr${}$", resolve.to_symbol());
     let link_null = format!("{}null", prefix);
     let link_uninit = format!("{}uninit", prefix);
     let link_raw = format!("{}raw", prefix);
@@ -1248,7 +1251,8 @@ fn expand_unique_ptr(ident: &RustName, types: &Types, explicit_impl: Option<&Imp
 
 fn expand_shared_ptr(ident: &RustName, types: &Types, explicit_impl: Option<&Impl>) -> TokenStream {
     let name = ident.rust.to_string();
-    let prefix = format!("cxxbridge1$shared_ptr${}$", ident.to_symbol(types));
+    let resolve = types.resolve(ident);
+    let prefix = format!("cxxbridge1$shared_ptr${}$", resolve.to_symbol());
     let link_null = format!("{}null", prefix);
     let link_uninit = format!("{}uninit", prefix);
     let link_clone = format!("{}clone", prefix);
@@ -1315,7 +1319,8 @@ fn expand_shared_ptr(ident: &RustName, types: &Types, explicit_impl: Option<&Imp
 
 fn expand_weak_ptr(ident: &RustName, types: &Types, explicit_impl: Option<&Impl>) -> TokenStream {
     let name = ident.rust.to_string();
-    let prefix = format!("cxxbridge1$weak_ptr${}$", ident.to_symbol(types));
+    let resolve = types.resolve(ident);
+    let prefix = format!("cxxbridge1$weak_ptr${}$", resolve.to_symbol());
     let link_null = format!("{}null", prefix);
     let link_clone = format!("{}clone", prefix);
     let link_downgrade = format!("{}downgrade", prefix);
@@ -1371,13 +1376,11 @@ fn expand_weak_ptr(ident: &RustName, types: &Types, explicit_impl: Option<&Impl>
 
 fn expand_cxx_vector(elem: &RustName, explicit_impl: Option<&Impl>, types: &Types) -> TokenStream {
     let name = elem.rust.to_string();
-    let prefix = format!("cxxbridge1$std$vector${}$", elem.to_symbol(types));
+    let resolve = types.resolve(elem);
+    let prefix = format!("cxxbridge1$std$vector${}$", resolve.to_symbol());
     let link_size = format!("{}size", prefix);
     let link_get_unchecked = format!("{}get_unchecked", prefix);
-    let unique_ptr_prefix = format!(
-        "cxxbridge1$unique_ptr$std$vector${}$",
-        elem.to_symbol(types)
-    );
+    let unique_ptr_prefix = format!("cxxbridge1$unique_ptr$std$vector${}$", resolve.to_symbol());
     let link_unique_ptr_null = format!("{}null", unique_ptr_prefix);
     let link_unique_ptr_raw = format!("{}raw", unique_ptr_prefix);
     let link_unique_ptr_get = format!("{}get", unique_ptr_prefix);
diff --git a/syntax/names.rs b/syntax/names.rs
index 50f6ebd..d818f86 100644
--- a/syntax/names.rs
+++ b/syntax/names.rs
@@ -1,4 +1,4 @@
-use crate::syntax::{Lifetimes, Pair, RustName, Symbol, Types};
+use crate::syntax::{Lifetimes, Pair, RustName, Symbol};
 use proc_macro2::{Ident, Span};
 use std::iter;
 use syn::punctuated::Punctuated;
@@ -35,8 +35,4 @@ impl RustName {
     pub fn span(&self) -> Span {
         self.rust.span()
     }
-
-    pub fn to_symbol(&self, types: &Types) -> Symbol {
-        types.resolve(self).to_symbol()
-    }
 }

